var fs = require('fs');

var walkPath = './';

var walk = function (dir, done) {
    fs.readdir(dir, function (error, list) {
        if (error) {
            return done(error);
        }

        var i = 0;

        (function next () {
            var file = list[i++];

            if (!file) {
                return done(null);
            }
            
            file = dir + '/' + file;
            
            fs.stat(file, function (error, stat) {
        
                if (stat && stat.isDirectory()) {
                    walk(file, function (error) {
                        next();
                    });
                } else {
                    // do stuff to file here
                    if(file.endsWith(".json")){
                        console.log(file)
                        fs.readFile(file, "utf8", function (er, d){
                            const lines = d.split("\n");
                            const fixedLines = lines.map(e=>{return e.split("// ")[0].split("//b")[0]})
                            var text;
                                text = JSON.stringify(JSON.parse(fixedLines.join("")))
                            fs.writeFile(file, text, function (){});
                            delete text, lines, fixedLines;
                        })
                    }else if(file.endsWith(".DS_Store")){
                        fs.unlinkSync(file)
                    }
                    next();
                }
            });
        })();
    });
};

// optional command line params
//      source for walk path
process.argv.forEach(function (val, index, array) {
    if (val.indexOf('source') !== -1) {
        walkPath = val.split('=')[1];
    }
});

console.log('-------------------------------------------------------------');
console.log('processing...');
console.log('-------------------------------------------------------------');

walk(walkPath, function(error) {
    if (error) {
        throw error;
    } else {
        console.log('-------------------------------------------------------------');
        console.log('finished.');
        console.log('-------------------------------------------------------------');
    }
});